---
title: API Gateway
---

[Skip to content](#_top)

[API Reference](https://developers.cloudflare.com/api/go)

Copy Markdown

Open in **Claude**Open in **ChatGPT**Open in **Cursor**

---

**Copy Markdown****View as Markdown**

# API Gateway

#### API GatewayConfigurations

##### [Get session identifier settings](https://developers.cloudflare.com/api/go/resources/api_gateway/subresources/configurations/methods/get)

client.APIGateway.Configurations.Get(ctx, params) (\*[Configuration](<https://developers.cloudflare.com/api/go/resources/api_gateway#(resource)%20api_gateway.configurations%20%3E%20(model)%20configuration%20%3E%20(schema)>), error)

GET/zones/{zone\_id}/api\_gateway/configuration

##### [Update session identifier settings](https://developers.cloudflare.com/api/go/resources/api_gateway/subresources/configurations/methods/update)

client.APIGateway.Configurations.Update(ctx, params) (\*[Configuration](<https://developers.cloudflare.com/api/go/resources/api_gateway#(resource)%20api_gateway.configurations%20%3E%20(model)%20configuration%20%3E%20(schema)>), error)

PUT/zones/{zone\_id}/api\_gateway/configuration

##### ModelsExpand Collapse

<details>

<summary>

type Configuration struct{…}

</summary>

<details>

<summary>

AuthIDCharacteristics \[]ConfigurationAuthIDCharacteristic

</summary>

One of the following:

<details>

<summary>

type ConfigurationAuthIDCharacteristicsAPIShieldAuthIDCharacteristic struct{…}

Auth ID Characteristic

</summary>

Name string

The name of the characteristic field, i.e., the header or cookie name.

maxLength128

<a href="#(resource)%20api_gateway.configurations%20%3E%20(model)%20configuration%20%3E%20(schema)%20%3E%20(property)%20auth_id_characteristics%20%3E%20(items)%20%3E%20(variant)%200%20%3E%20(property)%20name">Link to this property</a>

<details>

<summary>

Type ConfigurationAuthIDCharacteristicsAPIShieldAuthIDCharacteristicType

The type of characteristic.

</summary>

One of the following:

const ConfigurationAuthIDCharacteristicsAPIShieldAuthIDCharacteristicTypeHeader ConfigurationAuthIDCharacteristicsAPIShieldAuthIDCharacteristicType = "header"

<a href="#(resource)%20api_gateway.configurations%20%3E%20(model)%20configuration%20%3E%20(schema)%20%3E%20(property)%20auth_id_characteristics%20%3E%20(items)%20%3E%20(variant)%200%20%3E%20(property)%20type%20%3E%20(member)%200">Link to this property</a>

const ConfigurationAuthIDCharacteristicsAPIShieldAuthIDCharacteristicTypeCookie ConfigurationAuthIDCharacteristicsAPIShieldAuthIDCharacteristicType = "cookie"

<a href="#(resource)%20api_gateway.configurations%20%3E%20(model)%20configuration%20%3E%20(schema)%20%3E%20(property)%20auth_id_characteristics%20%3E%20(items)%20%3E%20(variant)%200%20%3E%20(property)%20type%20%3E%20(member)%201">Link to this property</a>

</details>

<a href="#(resource)%20api_gateway.configurations%20%3E%20(model)%20configuration%20%3E%20(schema)%20%3E%20(property)%20auth_id_characteristics%20%3E%20(items)%20%3E%20(variant)%200%20%3E%20(property)%20type">Link to this property</a>

</details>

<a href="#(resource)%20api_gateway.configurations%20%3E%20(model)%20configuration%20%3E%20(schema)%20%3E%20(property)%20auth_id_characteristics%20%3E%20(items)%20%3E%20(variant)%200">Link to this property</a>

<details>

<summary>

type ConfigurationAuthIDCharacteristicsAPIShieldAuthIDCharacteristicJWTClaim struct{…}

Auth ID Characteristic extracted from JWT Token Claims

</summary>

Name string

Claim location expressed as <code>$(token_config_id):$(json_path)</code>, where <code>token_config_id</code> is the ID of the token configuration used in validating the JWT, and <code>json_path</code> is a RFC 9535 JSONPath (<a href="https://goessner.net/articles/JsonPath/">https://goessner.net/articles/JsonPath/</a>, <a href="https://www.rfc-editor.org/rfc/rfc9535.html">https://www.rfc-editor.org/rfc/rfc9535.html</a>). The JSONPath expression may be in dot or bracket notation, may only specify literal keys or array indexes, and must return a singleton value, which will be interpreted as a string.

maxLength128

<a href="#(resource)%20api_gateway.configurations%20%3E%20(model)%20configuration%20%3E%20(schema)%20%3E%20(property)%20auth_id_characteristics%20%3E%20(items)%20%3E%20(variant)%201%20%3E%20(property)%20name">Link to this property</a>

Type ConfigurationAuthIDCharacteristicsAPIShieldAuthIDCharacteristicJWTClaimType

The type of characteristic.

<a href="#(resource)%20api_gateway.configurations%20%3E%20(model)%20configuration%20%3E%20(schema)%20%3E%20(property)%20auth_id_characteristics%20%3E%20(items)%20%3E%20(variant)%201%20%3E%20(property)%20type">Link to this property</a>

</details>

<a href="#(resource)%20api_gateway.configurations%20%3E%20(model)%20configuration%20%3E%20(schema)%20%3E%20(property)%20auth_id_characteristics%20%3E%20(items)%20%3E%20(variant)%201">Link to this property</a>

</details>

<a href="#(resource)%20api_gateway.configurations%20%3E%20(model)%20configuration%20%3E%20(schema)%20%3E%20(property)%20auth_id_characteristics">Link to this property</a>

</details>

[Link to this property](<#(resource)%20api_gateway.configurations%20%3E%20(model)%20configuration%20%3E%20(schema)>)

#### API GatewayDiscovery

##### [Export discovered API operations as OpenAPI schemas](https://developers.cloudflare.com/api/go/resources/api_gateway/subresources/discovery/methods/get)

client.APIGateway.Discovery.Get(ctx, query) (\*[DiscoveryGetResponse](<https://developers.cloudflare.com/api/go/resources/api_gateway#(resource)%20api_gateway.discovery%20%3E%20(model)%20DiscoveryGetResponse%20%3E%20(schema)>), error)

GET/zones/{zone\_id}/api\_gateway/discovery

##### ModelsExpand Collapse

<details>

<summary>

type DiscoveryOperation struct{…}

</summary>

ID string

UUID.

maxLength36

minLength36

<a href="#(resource)%20api_gateway.discovery%20%3E%20(model)%20discovery_operation%20%3E%20(schema)%20%3E%20(property)%20id">Link to this property</a>

Endpoint string

The endpoint which can contain path parameter templates in curly braces, each will be replaced from left to right with {varN}, starting with {var1}, during insertion. This will further be Cloudflare-normalized upon insertion. See: <a href="https://developers.cloudflare.com/rules/normalization/how-it-works/">https://developers.cloudflare.com/rules/normalization/how-it-works/</a>.

formaturi-template

maxLength4096

<a href="#(resource)%20api_gateway.discovery%20%3E%20(model)%20discovery_operation%20%3E%20(schema)%20%3E%20(property)%20endpoint">Link to this property</a>

Host string

RFC3986-compliant host.

formathostname

maxLength255

<a href="#(resource)%20api_gateway.discovery%20%3E%20(model)%20discovery_operation%20%3E%20(schema)%20%3E%20(property)%20host">Link to this property</a>

LastUpdated Time

formatdate-time

<a href="#(resource)%20api_gateway.discovery%20%3E%20(model)%20discovery_operation%20%3E%20(schema)%20%3E%20(property)%20last_updated">Link to this property</a>

<details>

<summary>

Method DiscoveryOperationMethod

The HTTP method used to access the endpoint.

</summary>

One of the following:

const DiscoveryOperationMethodGet DiscoveryOperationMethod = "GET"

<a href="#(resource)%20api_gateway.discovery%20%3E%20(model)%20discovery_operation%20%3E%20(schema)%20%3E%20(property)%20method%20%3E%20(member)%200">Link to this property</a>

const DiscoveryOperationMethodPost DiscoveryOperationMethod = "POST"

<a href="#(resource)%20api_gateway.discovery%20%3E%20(model)%20discovery_operation%20%3E%20(schema)%20%3E%20(property)%20method%20%3E%20(member)%201">Link to this property</a>

const DiscoveryOperationMethodHead DiscoveryOperationMethod = "HEAD"

<a href="#(resource)%20api_gateway.discovery%20%3E%20(model)%20discovery_operation%20%3E%20(schema)%20%3E%20(property)%20method%20%3E%20(member)%202">Link to this property</a>

const DiscoveryOperationMethodOptions DiscoveryOperationMethod = "OPTIONS"

<a href="#(resource)%20api_gateway.discovery%20%3E%20(model)%20discovery_operation%20%3E%20(schema)%20%3E%20(property)%20method%20%3E%20(member)%203">Link to this property</a>

const DiscoveryOperationMethodPut DiscoveryOperationMethod = "PUT"

<a href="#(resource)%20api_gateway.discovery%20%3E%20(model)%20discovery_operation%20%3E%20(schema)%20%3E%20(property)%20method%20%3E%20(member)%204">Link to this property</a>

const DiscoveryOperationMethodDelete DiscoveryOperationMethod = "DELETE"

<a href="#(resource)%20api_gateway.discovery%20%3E%20(model)%20discovery_operation%20%3E%20(schema)%20%3E%20(property)%20method%20%3E%20(member)%205">Link to this property</a>

const DiscoveryOperationMethodConnect DiscoveryOperationMethod = "CONNECT"

<a href="#(resource)%20api_gateway.discovery%20%3E%20(model)%20discovery_operation%20%3E%20(schema)%20%3E%20(property)%20method%20%3E%20(member)%206">Link to this property</a>

const DiscoveryOperationMethodPatch DiscoveryOperationMethod = "PATCH"

<a href="#(resource)%20api_gateway.discovery%20%3E%20(model)%20discovery_operation%20%3E%20(schema)%20%3E%20(property)%20method%20%3E%20(member)%207">Link to this property</a>

const DiscoveryOperationMethodTrace DiscoveryOperationMethod = "TRACE"

<a href="#(resource)%20api_gateway.discovery%20%3E%20(model)%20discovery_operation%20%3E%20(schema)%20%3E%20(property)%20method%20%3E%20(member)%208">Link to this property</a>

</details>

<a href="#(resource)%20api_gateway.discovery%20%3E%20(model)%20discovery_operation%20%3E%20(schema)%20%3E%20(property)%20method">Link to this property</a>

<details>

<summary>

Origin \[]DiscoveryOperationOrigin

API discovery engine(s) that discovered this operation

</summary>

One of the following:

const DiscoveryOperationOriginMl DiscoveryOperationOrigin = "ML"

<a href="#(resource)%20api_gateway.discovery%20%3E%20(model)%20discovery_operation%20%3E%20(schema)%20%3E%20(property)%20origin%20%3E%20(items)%20%3E%20(member)%200">Link to this property</a>

const DiscoveryOperationOriginSessionIdentifier DiscoveryOperationOrigin = "SessionIdentifier"

<a href="#(resource)%20api_gateway.discovery%20%3E%20(model)%20discovery_operation%20%3E%20(schema)%20%3E%20(property)%20origin%20%3E%20(items)%20%3E%20(member)%201">Link to this property</a>

const DiscoveryOperationOriginLabelDiscovery DiscoveryOperationOrigin = "LabelDiscovery"

<a href="#(resource)%20api_gateway.discovery%20%3E%20(model)%20discovery_operation%20%3E%20(schema)%20%3E%20(property)%20origin%20%3E%20(items)%20%3E%20(member)%202">Link to this property</a>

</details>

<a href="#(resource)%20api_gateway.discovery%20%3E%20(model)%20discovery_operation%20%3E%20(schema)%20%3E%20(property)%20origin">Link to this property</a>

<details>

<summary>

State DiscoveryOperationState

State of operation in API Discovery

- <code>review</code> - Operation is not saved into API Shield Endpoint Management
- <code>saved</code> - Operation is saved into API Shield Endpoint Management
- <code>ignored</code> - Operation is marked as ignored

</summary>

One of the following:

const DiscoveryOperationStateReview DiscoveryOperationState = "review"

<a href="#(resource)%20api_gateway.discovery%20%3E%20(model)%20discovery_operation%20%3E%20(schema)%20%3E%20(property)%20state%20%3E%20(member)%200">Link to this property</a>

const DiscoveryOperationStateSaved DiscoveryOperationState = "saved"

<a href="#(resource)%20api_gateway.discovery%20%3E%20(model)%20discovery_operation%20%3E%20(schema)%20%3E%20(property)%20state%20%3E%20(member)%201">Link to this property</a>

const DiscoveryOperationStateIgnored DiscoveryOperationState = "ignored"

<a href="#(resource)%20api_gateway.discovery%20%3E%20(model)%20discovery_operation%20%3E%20(schema)%20%3E%20(property)%20state%20%3E%20(member)%202">Link to this property</a>

</details>

<a href="#(resource)%20api_gateway.discovery%20%3E%20(model)%20discovery_operation%20%3E%20(schema)%20%3E%20(property)%20state">Link to this property</a>

<details>

<summary>

Features DiscoveryOperationFeaturesOptional

</summary>

<details>

<summary>

TrafficStats DiscoveryOperationFeaturesTrafficStatsOptional

</summary>

LastUpdated Time

formatdate-time

<a href="#(resource)%20api_gateway.discovery%20%3E%20(model)%20discovery_operation%20%3E%20(schema)%20%3E%20(property)%20features%20%3E%20(property)%20traffic_stats%20%3E%20(property)%20last_updated">Link to this property</a>

PeriodSeconds int64

The period in seconds these statistics were computed over

<a href="#(resource)%20api_gateway.discovery%20%3E%20(model)%20discovery_operation%20%3E%20(schema)%20%3E%20(property)%20features%20%3E%20(property)%20traffic_stats%20%3E%20(property)%20period_seconds">Link to this property</a>

Requests float64

The average number of requests seen during this period

formatfloat

<a href="#(resource)%20api_gateway.discovery%20%3E%20(model)%20discovery_operation%20%3E%20(schema)%20%3E%20(property)%20features%20%3E%20(property)%20traffic_stats%20%3E%20(property)%20requests">Link to this property</a>

</details>

<a href="#(resource)%20api_gateway.discovery%20%3E%20(model)%20discovery_operation%20%3E%20(schema)%20%3E%20(property)%20features%20%3E%20(property)%20traffic_stats">Link to this property</a>

</details>

<a href="#(resource)%20api_gateway.discovery%20%3E%20(model)%20discovery_operation%20%3E%20(schema)%20%3E%20(property)%20features">Link to this property</a>

</details>

[Link to this property](<#(resource)%20api_gateway.discovery%20%3E%20(model)%20discovery_operation%20%3E%20(schema)>)

#### API GatewayDiscoveryOperations

##### [List discovered web and API operations](https://developers.cloudflare.com/api/go/resources/api_gateway/subresources/discovery/subresources/operations/methods/list)

client.APIGateway.Discovery.Operations.List(ctx, params) (\*V4PagePaginationArray\[[DiscoveryOperation](<https://developers.cloudflare.com/api/go/resources/api_gateway#(resource)%20api_gateway.discovery%20%3E%20(model)%20discovery_operation%20%3E%20(schema)>)], error)

GET/zones/{zone\_id}/api\_gateway/discovery/operations

##### [Edit discovered web and API operations](https://developers.cloudflare.com/api/go/resources/api_gateway/subresources/discovery/subresources/operations/methods/bulk_edit)

client.APIGateway.Discovery.Operations.BulkEdit(ctx, params) (\*[DiscoveryOperationBulkEditResponse](<https://developers.cloudflare.com/api/go/resources/api_gateway#(resource)%20api_gateway.discovery.operations%20%3E%20(model)%20DiscoveryOperationBulkEditResponse%20%3E%20(schema)>), error)

PATCH/zones/{zone\_id}/api\_gateway/discovery/operations

#### API GatewayLabels

##### [List operation labels](https://developers.cloudflare.com/api/go/resources/api_gateway/subresources/labels/methods/list)

client.APIGateway.Labels.List(ctx, params) (\*V4PagePaginationArray\[[LabelListResponse](<https://developers.cloudflare.com/api/go/resources/api_gateway#(resource)%20api_gateway.labels%20%3E%20(model)%20LabelListResponse%20%3E%20(schema)>)], error)

GET/zones/{zone\_id}/api\_gateway/labels

#### API GatewayLabelsUser

##### [Create user-defined operation labels](https://developers.cloudflare.com/api/go/resources/api_gateway/subresources/labels/subresources/user/methods/bulk_create)

client.APIGateway.Labels.User.BulkNew(ctx, params) (\*SinglePage\[[LabelUserBulkNewResponse](<https://developers.cloudflare.com/api/go/resources/api_gateway#(resource)%20api_gateway.labels.user%20%3E%20(model)%20LabelUserBulkNewResponse%20%3E%20(schema)>)], error)

POST/zones/{zone\_id}/api\_gateway/labels/user

##### [Delete user-defined operation labels](https://developers.cloudflare.com/api/go/resources/api_gateway/subresources/labels/subresources/user/methods/bulk_delete)

client.APIGateway.Labels.User.BulkDelete(ctx, body) (\*SinglePage\[[LabelUserBulkDeleteResponse](<https://developers.cloudflare.com/api/go/resources/api_gateway#(resource)%20api_gateway.labels.user%20%3E%20(model)%20LabelUserBulkDeleteResponse%20%3E%20(schema)>)], error)

DELETE/zones/{zone\_id}/api\_gateway/labels/user

##### [Get a user-defined operation label](https://developers.cloudflare.com/api/go/resources/api_gateway/subresources/labels/subresources/user/methods/get)

client.APIGateway.Labels.User.Get(ctx, name, params) (\*[LabelUserGetResponse](<https://developers.cloudflare.com/api/go/resources/api_gateway#(resource)%20api_gateway.labels.user%20%3E%20(model)%20LabelUserGetResponse%20%3E%20(schema)>), error)

GET/zones/{zone\_id}/api\_gateway/labels/user/{name}

##### [Update a user-defined operation label](https://developers.cloudflare.com/api/go/resources/api_gateway/subresources/labels/subresources/user/methods/update)

client.APIGateway.Labels.User.Update(ctx, name, params) (\*[LabelUserUpdateResponse](<https://developers.cloudflare.com/api/go/resources/api_gateway#(resource)%20api_gateway.labels.user%20%3E%20(model)%20LabelUserUpdateResponse%20%3E%20(schema)>), error)

PUT/zones/{zone\_id}/api\_gateway/labels/user/{name}

##### [Edit a user-defined operation label](https://developers.cloudflare.com/api/go/resources/api_gateway/subresources/labels/subresources/user/methods/edit)

client.APIGateway.Labels.User.Edit(ctx, name, params) (\*[LabelUserEditResponse](<https://developers.cloudflare.com/api/go/resources/api_gateway#(resource)%20api_gateway.labels.user%20%3E%20(model)%20LabelUserEditResponse%20%3E%20(schema)>), error)

PATCH/zones/{zone\_id}/api\_gateway/labels/user/{name}

##### [Delete a user-defined operation label](https://developers.cloudflare.com/api/go/resources/api_gateway/subresources/labels/subresources/user/methods/delete)

client.APIGateway.Labels.User.Delete(ctx, name, body) (\*[LabelUserDeleteResponse](<https://developers.cloudflare.com/api/go/resources/api_gateway#(resource)%20api_gateway.labels.user%20%3E%20(model)%20LabelUserDeleteResponse%20%3E%20(schema)>), error)

DELETE/zones/{zone\_id}/api\_gateway/labels/user/{name}

#### API GatewayLabelsUserResources

#### API GatewayLabelsUserResourcesOperation

##### [Replace operations attached to a user-defined label](https://developers.cloudflare.com/api/go/resources/api_gateway/subresources/labels/subresources/user/subresources/resources/subresources/operation/methods/update)

client.APIGateway.Labels.User.Resources.Operation.Update(ctx, name, params) (\*[LabelUserResourceOperationUpdateResponse](<https://developers.cloudflare.com/api/go/resources/api_gateway#(resource)%20api_gateway.labels.user.resources.operation%20%3E%20(model)%20LabelUserResourceOperationUpdateResponse%20%3E%20(schema)>), error)

PUT/zones/{zone\_id}/api\_gateway/labels/user/{name}/resources/operation

#### API GatewayLabelsManaged

##### [Get a managed operation label](https://developers.cloudflare.com/api/go/resources/api_gateway/subresources/labels/subresources/managed/methods/get)

client.APIGateway.Labels.Managed.Get(ctx, name, params) (\*[LabelManagedGetResponse](<https://developers.cloudflare.com/api/go/resources/api_gateway#(resource)%20api_gateway.labels.managed%20%3E%20(model)%20LabelManagedGetResponse%20%3E%20(schema)>), error)

GET/zones/{zone\_id}/api\_gateway/labels/managed/{name}

#### API GatewayLabelsManagedResources

#### API GatewayLabelsManagedResourcesOperation

##### [Replace operations attached to a managed label](https://developers.cloudflare.com/api/go/resources/api_gateway/subresources/labels/subresources/managed/subresources/resources/subresources/operation/methods/update)

client.APIGateway.Labels.Managed.Resources.Operation.Update(ctx, name, params) (\*[LabelManagedResourceOperationUpdateResponse](<https://developers.cloudflare.com/api/go/resources/api_gateway#(resource)%20api_gateway.labels.managed.resources.operation%20%3E%20(model)%20LabelManagedResourceOperationUpdateResponse%20%3E%20(schema)>), error)

PUT/zones/{zone\_id}/api\_gateway/labels/managed/{name}/resources/operation

#### API GatewayOperations

##### [List web and API operations](https://developers.cloudflare.com/api/go/resources/api_gateway/subresources/operations/methods/list)

client.APIGateway.Operations.List(ctx, params) (\*V4PagePaginationArray\[[OperationListResponse](<https://developers.cloudflare.com/api/go/resources/api_gateway#(resource)%20api_gateway.operations%20%3E%20(model)%20OperationListResponse%20%3E%20(schema)>)], error)

GET/zones/{zone\_id}/api\_gateway/operations

##### [Get a web or API operation](https://developers.cloudflare.com/api/go/resources/api_gateway/subresources/operations/methods/get)

client.APIGateway.Operations.Get(ctx, operationID, params) (\*[OperationGetResponse](<https://developers.cloudflare.com/api/go/resources/api_gateway#(resource)%20api_gateway.operations%20%3E%20(model)%20OperationGetResponse%20%3E%20(schema)>), error)

GET/zones/{zone\_id}/api\_gateway/operations/{operation\_id}

##### [Create a web or API operation](https://developers.cloudflare.com/api/go/resources/api_gateway/subresources/operations/methods/create)

client.APIGateway.Operations.New(ctx, params) (\*[OperationNewResponse](<https://developers.cloudflare.com/api/go/resources/api_gateway#(resource)%20api_gateway.operations%20%3E%20(model)%20OperationNewResponse%20%3E%20(schema)>), error)

POST/zones/{zone\_id}/api\_gateway/operations/item

##### [Delete a web or API operation](https://developers.cloudflare.com/api/go/resources/api_gateway/subresources/operations/methods/delete)

client.APIGateway.Operations.Delete(ctx, operationID, body) (\*[OperationDeleteResponse](<https://developers.cloudflare.com/api/go/resources/api_gateway#(resource)%20api_gateway.operations%20%3E%20(model)%20OperationDeleteResponse%20%3E%20(schema)>), error)

DELETE/zones/{zone\_id}/api\_gateway/operations/{operation\_id}

##### [Create web or API operations](https://developers.cloudflare.com/api/go/resources/api_gateway/subresources/operations/methods/bulk_create)

client.APIGateway.Operations.BulkNew(ctx, params) (\*SinglePage\[[OperationBulkNewResponse](<https://developers.cloudflare.com/api/go/resources/api_gateway#(resource)%20api_gateway.operations%20%3E%20(model)%20OperationBulkNewResponse%20%3E%20(schema)>)], error)

POST/zones/{zone\_id}/api\_gateway/operations

##### [Delete web or API operations](https://developers.cloudflare.com/api/go/resources/api_gateway/subresources/operations/methods/bulk_delete)

client.APIGateway.Operations.BulkDelete(ctx, body) (\*[OperationBulkDeleteResponse](<https://developers.cloudflare.com/api/go/resources/api_gateway#(resource)%20api_gateway.operations%20%3E%20(model)%20OperationBulkDeleteResponse%20%3E%20(schema)>), error)

DELETE/zones/{zone\_id}/api\_gateway/operations

##### ModelsExpand Collapse

<details>

<summary>

type APIShield struct{…}

</summary>

Endpoint string

The endpoint which can contain path parameter templates in curly braces, each will be replaced from left to right with {varN}, starting with {var1}, during insertion. This will further be Cloudflare-normalized upon insertion. See: <a href="https://developers.cloudflare.com/rules/normalization/how-it-works/">https://developers.cloudflare.com/rules/normalization/how-it-works/</a>.

formaturi-template

maxLength4096

<a href="#(resource)%20api_gateway.operations%20%3E%20(model)%20api-shield%20%3E%20(schema)%20%3E%20(property)%20endpoint">Link to this property</a>

Host string

RFC3986-compliant host.

formathostname

maxLength255

<a href="#(resource)%20api_gateway.operations%20%3E%20(model)%20api-shield%20%3E%20(schema)%20%3E%20(property)%20host">Link to this property</a>

LastUpdated Time

formatdate-time

<a href="#(resource)%20api_gateway.operations%20%3E%20(model)%20api-shield%20%3E%20(schema)%20%3E%20(property)%20last_updated">Link to this property</a>

<details>

<summary>

Method APIShieldMethod

The HTTP method used to access the endpoint.

</summary>

One of the following:

const APIShieldMethodGet APIShieldMethod = "GET"

<a href="#(resource)%20api_gateway.operations%20%3E%20(model)%20api-shield%20%3E%20(schema)%20%3E%20(property)%20method%20%3E%20(member)%200">Link to this property</a>

const APIShieldMethodPost APIShieldMethod = "POST"

<a href="#(resource)%20api_gateway.operations%20%3E%20(model)%20api-shield%20%3E%20(schema)%20%3E%20(property)%20method%20%3E%20(member)%201">Link to this property</a>

const APIShieldMethodHead APIShieldMethod = "HEAD"

<a href="#(resource)%20api_gateway.operations%20%3E%20(model)%20api-shield%20%3E%20(schema)%20%3E%20(property)%20method%20%3E%20(member)%202">Link to this property</a>

const APIShieldMethodOptions APIShieldMethod = "OPTIONS"

<a href="#(resource)%20api_gateway.operations%20%3E%20(model)%20api-shield%20%3E%20(schema)%20%3E%20(property)%20method%20%3E%20(member)%203">Link to this property</a>

const APIShieldMethodPut APIShieldMethod = "PUT"

<a href="#(resource)%20api_gateway.operations%20%3E%20(model)%20api-shield%20%3E%20(schema)%20%3E%20(property)%20method%20%3E%20(member)%204">Link to this property</a>

const APIShieldMethodDelete APIShieldMethod = "DELETE"

<a href="#(resource)%20api_gateway.operations%20%3E%20(model)%20api-shield%20%3E%20(schema)%20%3E%20(property)%20method%20%3E%20(member)%205">Link to this property</a>

const APIShieldMethodConnect APIShieldMethod = "CONNECT"

<a href="#(resource)%20api_gateway.operations%20%3E%20(model)%20api-shield%20%3E%20(schema)%20%3E%20(property)%20method%20%3E%20(member)%206">Link to this property</a>

const APIShieldMethodPatch APIShieldMethod = "PATCH"

<a href="#(resource)%20api_gateway.operations%20%3E%20(model)%20api-shield%20%3E%20(schema)%20%3E%20(property)%20method%20%3E%20(member)%207">Link to this property</a>

const APIShieldMethodTrace APIShieldMethod = "TRACE"

<a href="#(resource)%20api_gateway.operations%20%3E%20(model)%20api-shield%20%3E%20(schema)%20%3E%20(property)%20method%20%3E%20(member)%208">Link to this property</a>

</details>

<a href="#(resource)%20api_gateway.operations%20%3E%20(model)%20api-shield%20%3E%20(schema)%20%3E%20(property)%20method">Link to this property</a>

OperationID string

UUID.

maxLength36

minLength36

<a href="#(resource)%20api_gateway.operations%20%3E%20(model)%20api-shield%20%3E%20(schema)%20%3E%20(property)%20operation_id">Link to this property</a>

</details>

[Link to this property](<#(resource)%20api_gateway.operations%20%3E%20(model)%20api-shield%20%3E%20(schema)>)

#### API GatewayOperationsLabels

##### [Replace labels on a web or API operation](https://developers.cloudflare.com/api/go/resources/api_gateway/subresources/operations/subresources/labels/methods/update)

client.APIGateway.Operations.Labels.Update(ctx, operationID, params) (\*[OperationLabelUpdateResponse](<https://developers.cloudflare.com/api/go/resources/api_gateway#(resource)%20api_gateway.operations.labels%20%3E%20(model)%20OperationLabelUpdateResponse%20%3E%20(schema)>), error)

PUT/zones/{zone\_id}/api\_gateway/operations/{operation\_id}/labels

##### [Attach labels to a web or API operation](https://developers.cloudflare.com/api/go/resources/api_gateway/subresources/operations/subresources/labels/methods/create)

client.APIGateway.Operations.Labels.New(ctx, operationID, params) (\*[OperationLabelNewResponse](<https://developers.cloudflare.com/api/go/resources/api_gateway#(resource)%20api_gateway.operations.labels%20%3E%20(model)%20OperationLabelNewResponse%20%3E%20(schema)>), error)

POST/zones/{zone\_id}/api\_gateway/operations/{operation\_id}/labels

##### [Remove labels from a web or API operation](https://developers.cloudflare.com/api/go/resources/api_gateway/subresources/operations/subresources/labels/methods/delete)

client.APIGateway.Operations.Labels.Delete(ctx, operationID, body) (\*[OperationLabelDeleteResponse](<https://developers.cloudflare.com/api/go/resources/api_gateway#(resource)%20api_gateway.operations.labels%20%3E%20(model)%20OperationLabelDeleteResponse%20%3E%20(schema)>), error)

DELETE/zones/{zone\_id}/api\_gateway/operations/{operation\_id}/labels

##### [Replace labels on web or API operations](https://developers.cloudflare.com/api/go/resources/api_gateway/subresources/operations/subresources/labels/methods/bulk_update)

client.APIGateway.Operations.Labels.BulkUpdate(ctx, params) (\*SinglePage\[[OperationLabelBulkUpdateResponse](<https://developers.cloudflare.com/api/go/resources/api_gateway#(resource)%20api_gateway.operations.labels%20%3E%20(model)%20OperationLabelBulkUpdateResponse%20%3E%20(schema)>)], error)

PUT/zones/{zone\_id}/api\_gateway/operations/labels

##### [Attach labels to web or API operations](https://developers.cloudflare.com/api/go/resources/api_gateway/subresources/operations/subresources/labels/methods/bulk_create)

client.APIGateway.Operations.Labels.BulkNew(ctx, params) (\*SinglePage\[[OperationLabelBulkNewResponse](<https://developers.cloudflare.com/api/go/resources/api_gateway#(resource)%20api_gateway.operations.labels%20%3E%20(model)%20OperationLabelBulkNewResponse%20%3E%20(schema)>)], error)

POST/zones/{zone\_id}/api\_gateway/operations/labels

##### [Remove labels from web or API operations](https://developers.cloudflare.com/api/go/resources/api_gateway/subresources/operations/subresources/labels/methods/bulk_delete)

client.APIGateway.Operations.Labels.BulkDelete(ctx, body) (\*SinglePage\[[OperationLabelBulkDeleteResponse](<https://developers.cloudflare.com/api/go/resources/api_gateway#(resource)%20api_gateway.operations.labels%20%3E%20(model)%20OperationLabelBulkDeleteResponse%20%3E%20(schema)>)], error)

DELETE/zones/{zone\_id}/api\_gateway/operations/labels

#### API GatewayOperationsSchema Validation

##### [Retrieve operation-level schema validation settings](https://developers.cloudflare.com/api/go/resources/api_gateway/subresources/operations/subresources/schema_validation/methods/get)

Deprecated

client.APIGateway.Operations.SchemaValidation.Get(ctx, operationID, query) (\*[OperationSchemaValidationGetResponse](<https://developers.cloudflare.com/api/go/resources/api_gateway#(resource)%20api_gateway.operations.schema_validation%20%3E%20(model)%20OperationSchemaValidationGetResponse%20%3E%20(schema)>), error)

GET/zones/{zone\_id}/api\_gateway/operations/{operation\_id}/schema\_validation

##### [Update operation-level schema validation settings](https://developers.cloudflare.com/api/go/resources/api_gateway/subresources/operations/subresources/schema_validation/methods/update)

Deprecated

client.APIGateway.Operations.SchemaValidation.Update(ctx, operationID, params) (\*[OperationSchemaValidationUpdateResponse](<https://developers.cloudflare.com/api/go/resources/api_gateway#(resource)%20api_gateway.operations.schema_validation%20%3E%20(model)%20OperationSchemaValidationUpdateResponse%20%3E%20(schema)>), error)

PUT/zones/{zone\_id}/api\_gateway/operations/{operation\_id}/schema\_validation

##### [Update multiple operation-level schema validation settings](https://developers.cloudflare.com/api/go/resources/api_gateway/subresources/operations/subresources/schema_validation/methods/edit)

Deprecated

client.APIGateway.Operations.SchemaValidation.Edit(ctx, params) (\*[SettingsMultipleRequest](<https://developers.cloudflare.com/api/go/resources/api_gateway#(resource)%20api_gateway.operations.schema_validation%20%3E%20(model)%20settings_multiple_request%20%3E%20(schema)>), error)

PATCH/zones/{zone\_id}/api\_gateway/operations/schema\_validation

##### ModelsExpand Collapse

<details>

<summary>

type SettingsMultipleRequest map\[string, SettingsMultipleRequestItem]

</summary>

<details>

<summary>

MitigationAction SettingsMultipleRequestItemMitigationActionOptional

When set, this applies a mitigation action to this operation

- <code>log</code> log request when request does not conform to schema for this operation
- <code>block</code> deny access to the site when request does not conform to schema for this operation
- <code>none</code> will skip mitigation for this operation
- <code>null</code> indicates that no operation level mitigation is in place, see Zone Level Schema Validation Settings for mitigation action that will be applied

</summary>

One of the following:

const SettingsMultipleRequestItemMitigationActionLog SettingsMultipleRequestItemMitigationAction = "log"

<a href="#(resource)%20api_gateway.operations.schema_validation%20%3E%20(model)%20settings_multiple_request%20%3E%20(schema)%20%3E%20(items)%20%3E%20(property)%20mitigation_action%20%3E%20(member)%200">Link to this property</a>

const SettingsMultipleRequestItemMitigationActionBlock SettingsMultipleRequestItemMitigationAction = "block"

<a href="#(resource)%20api_gateway.operations.schema_validation%20%3E%20(model)%20settings_multiple_request%20%3E%20(schema)%20%3E%20(items)%20%3E%20(property)%20mitigation_action%20%3E%20(member)%201">Link to this property</a>

const SettingsMultipleRequestItemMitigationActionNone SettingsMultipleRequestItemMitigationAction = "none"

<a href="#(resource)%20api_gateway.operations.schema_validation%20%3E%20(model)%20settings_multiple_request%20%3E%20(schema)%20%3E%20(items)%20%3E%20(property)%20mitigation_action%20%3E%20(member)%202">Link to this property</a>

</details>

<a href="#(resource)%20api_gateway.operations.schema_validation%20%3E%20(model)%20settings_multiple_request%20%3E%20(schema)%20%3E%20(items)%20%3E%20(property)%20mitigation_action">Link to this property</a>

</details>

[Link to this property](<#(resource)%20api_gateway.operations.schema_validation%20%3E%20(model)%20settings_multiple_request%20%3E%20(schema)>)

#### API GatewaySchemas

##### [Export web and API operations as OpenAPI schemas](https://developers.cloudflare.com/api/go/resources/api_gateway/subresources/schemas/methods/list)

client.APIGateway.Schemas.List(ctx, params) (\*[SchemaListResponse](<https://developers.cloudflare.com/api/go/resources/api_gateway#(resource)%20api_gateway.schemas%20%3E%20(model)%20SchemaListResponse%20%3E%20(schema)>), error)

GET/zones/{zone\_id}/api\_gateway/schemas

#### API GatewaySettings

##### ModelsExpand Collapse

<details>

<summary>

type Settings struct{…}

</summary>

<details>

<summary>

ValidationDefaultMitigationAction SettingsValidationDefaultMitigationActionOptional

The default mitigation action used when there is no mitigation action defined on the operation

Mitigation actions are as follows:

- <code>log</code> - log request when request does not conform to schema
- <code>block</code> - deny access to the site when request does not conform to schema

A special value of of <code>none</code> will skip running schema validation entirely for the request when there is no mitigation action defined on the operation

</summary>

One of the following:

const SettingsValidationDefaultMitigationActionNone SettingsValidationDefaultMitigationAction = "none"

<a href="#(resource)%20api_gateway.settings%20%3E%20(model)%20settings%20%3E%20(schema)%20%3E%20(property)%20validation_default_mitigation_action%20%3E%20(member)%200">Link to this property</a>

const SettingsValidationDefaultMitigationActionLog SettingsValidationDefaultMitigationAction = "log"

<a href="#(resource)%20api_gateway.settings%20%3E%20(model)%20settings%20%3E%20(schema)%20%3E%20(property)%20validation_default_mitigation_action%20%3E%20(member)%201">Link to this property</a>

const SettingsValidationDefaultMitigationActionBlock SettingsValidationDefaultMitigationAction = "block"

<a href="#(resource)%20api_gateway.settings%20%3E%20(model)%20settings%20%3E%20(schema)%20%3E%20(property)%20validation_default_mitigation_action%20%3E%20(member)%202">Link to this property</a>

</details>

<a href="#(resource)%20api_gateway.settings%20%3E%20(model)%20settings%20%3E%20(schema)%20%3E%20(property)%20validation_default_mitigation_action">Link to this property</a>

ValidationOverrideMitigationAction SettingsValidationOverrideMitigationActionOptional

When set, this overrides both zone level and operation level mitigation actions.

- <code>none</code> will skip running schema validation entirely for the request
- <code>null</code> indicates that no override is in place

<a href="#(resource)%20api_gateway.settings%20%3E%20(model)%20settings%20%3E%20(schema)%20%3E%20(property)%20validation_override_mitigation_action">Link to this property</a>

</details>

[Link to this property](<#(resource)%20api_gateway.settings%20%3E%20(model)%20settings%20%3E%20(schema)>)

#### API GatewaySettingsSchema Validation

##### [Retrieve zone level schema validation settings](https://developers.cloudflare.com/api/go/resources/api_gateway/subresources/settings/subresources/schema_validation/methods/get)

Deprecated

client.APIGateway.Settings.SchemaValidation.Get(ctx, query) (\*[Settings](<https://developers.cloudflare.com/api/go/resources/api_gateway#(resource)%20api_gateway.settings%20%3E%20(model)%20settings%20%3E%20(schema)>), error)

GET/zones/{zone\_id}/api\_gateway/settings/schema\_validation

##### [Update zone level schema validation settings](https://developers.cloudflare.com/api/go/resources/api_gateway/subresources/settings/subresources/schema_validation/methods/update)

Deprecated

client.APIGateway.Settings.SchemaValidation.Update(ctx, params) (\*[Settings](<https://developers.cloudflare.com/api/go/resources/api_gateway#(resource)%20api_gateway.settings%20%3E%20(model)%20settings%20%3E%20(schema)>), error)

PUT/zones/{zone\_id}/api\_gateway/settings/schema\_validation

##### [Update zone level schema validation settings](https://developers.cloudflare.com/api/go/resources/api_gateway/subresources/settings/subresources/schema_validation/methods/edit)

Deprecated

client.APIGateway.Settings.SchemaValidation.Edit(ctx, params) (\*[Settings](<https://developers.cloudflare.com/api/go/resources/api_gateway#(resource)%20api_gateway.settings%20%3E%20(model)%20settings%20%3E%20(schema)>), error)

PATCH/zones/{zone\_id}/api\_gateway/settings/schema\_validation

#### API GatewayUser Schemas

##### [Retrieve information about all schemas on a zone](https://developers.cloudflare.com/api/go/resources/api_gateway/subresources/user_schemas/methods/list)

Deprecated

client.APIGateway.UserSchemas.List(ctx, params) (\*V4PagePaginationArray\[[OldPublicSchema](<https://developers.cloudflare.com/api/go/resources/api_gateway#(resource)%20api_gateway.user_schemas%20%3E%20(model)%20old_public_schema%20%3E%20(schema)>)], error)

GET/zones/{zone\_id}/api\_gateway/user\_schemas

##### [Retrieve information about a specific schema on a zone](https://developers.cloudflare.com/api/go/resources/api_gateway/subresources/user_schemas/methods/get)

Deprecated

client.APIGateway.UserSchemas.Get(ctx, schemaID, params) (\*[OldPublicSchema](<https://developers.cloudflare.com/api/go/resources/api_gateway#(resource)%20api_gateway.user_schemas%20%3E%20(model)%20old_public_schema%20%3E%20(schema)>), error)

GET/zones/{zone\_id}/api\_gateway/user\_schemas/{schema\_id}

##### [Upload a legacy schema](https://developers.cloudflare.com/api/go/resources/api_gateway/subresources/user_schemas/methods/create)

Deprecated

client.APIGateway.UserSchemas.New(ctx, params) (\*[UserSchemaNewResponse](<https://developers.cloudflare.com/api/go/resources/api_gateway#(resource)%20api_gateway.user_schemas%20%3E%20(model)%20UserSchemaNewResponse%20%3E%20(schema)>), error)

POST/zones/{zone\_id}/api\_gateway/user\_schemas

##### [Enable validation for a schema](https://developers.cloudflare.com/api/go/resources/api_gateway/subresources/user_schemas/methods/edit)

Deprecated

client.APIGateway.UserSchemas.Edit(ctx, schemaID, params) (\*[OldPublicSchema](<https://developers.cloudflare.com/api/go/resources/api_gateway#(resource)%20api_gateway.user_schemas%20%3E%20(model)%20old_public_schema%20%3E%20(schema)>), error)

PATCH/zones/{zone\_id}/api\_gateway/user\_schemas/{schema\_id}

##### [Delete a schema](https://developers.cloudflare.com/api/go/resources/api_gateway/subresources/user_schemas/methods/delete)

Deprecated

client.APIGateway.UserSchemas.Delete(ctx, schemaID, body) (\*[UserSchemaDeleteResponse](<https://developers.cloudflare.com/api/go/resources/api_gateway#(resource)%20api_gateway.user_schemas%20%3E%20(model)%20UserSchemaDeleteResponse%20%3E%20(schema)>), error)

DELETE/zones/{zone\_id}/api\_gateway/user\_schemas/{schema\_id}

##### ModelsExpand Collapse

<details>

<summary>

type Message \[]MessageItem

</summary>

Code int64

minimum1000

<a href="#(resource)%20api_gateway.user_schemas%20%3E%20(model)%20message%20%3E%20(schema)%20%3E%20(items)%20%3E%20(property)%20code">Link to this property</a>

Message string

<a href="#(resource)%20api_gateway.user_schemas%20%3E%20(model)%20message%20%3E%20(schema)%20%3E%20(items)%20%3E%20(property)%20message">Link to this property</a>

DocumentationURL stringOptional

<a href="#(resource)%20api_gateway.user_schemas%20%3E%20(model)%20message%20%3E%20(schema)%20%3E%20(items)%20%3E%20(property)%20documentation_url">Link to this property</a>

<details>

<summary>

Source MessageItemSourceOptional

</summary>

Pointer stringOptional

<a href="#(resource)%20api_gateway.user_schemas%20%3E%20(model)%20message%20%3E%20(schema)%20%3E%20(items)%20%3E%20(property)%20source%20%3E%20(property)%20pointer">Link to this property</a>

</details>

<a href="#(resource)%20api_gateway.user_schemas%20%3E%20(model)%20message%20%3E%20(schema)%20%3E%20(items)%20%3E%20(property)%20source">Link to this property</a>

</details>

[Link to this property](<#(resource)%20api_gateway.user_schemas%20%3E%20(model)%20message%20%3E%20(schema)>)

<details>

<summary>

type OldPublicSchema struct{…}

</summary>

CreatedAt Time

formatdate-time

<a href="#(resource)%20api_gateway.user_schemas%20%3E%20(model)%20old_public_schema%20%3E%20(schema)%20%3E%20(property)%20created_at">Link to this property</a>

Kind OldPublicSchemaKind

Kind of schema

<a href="#(resource)%20api_gateway.user_schemas%20%3E%20(model)%20old_public_schema%20%3E%20(schema)%20%3E%20(property)%20kind">Link to this property</a>

Name string

Name of the schema

<a href="#(resource)%20api_gateway.user_schemas%20%3E%20(model)%20old_public_schema%20%3E%20(schema)%20%3E%20(property)%20name">Link to this property</a>

SchemaID string

UUID.

maxLength36

minLength36

<a href="#(resource)%20api_gateway.user_schemas%20%3E%20(model)%20old_public_schema%20%3E%20(schema)%20%3E%20(property)%20schema_id">Link to this property</a>

Source stringOptional

Source of the schema

<a href="#(resource)%20api_gateway.user_schemas%20%3E%20(model)%20old_public_schema%20%3E%20(schema)%20%3E%20(property)%20source">Link to this property</a>

ValidationEnabled boolOptional

Flag whether schema is enabled for validation.

<a href="#(resource)%20api_gateway.user_schemas%20%3E%20(model)%20old_public_schema%20%3E%20(schema)%20%3E%20(property)%20validation_enabled">Link to this property</a>

</details>

[Link to this property](<#(resource)%20api_gateway.user_schemas%20%3E%20(model)%20old_public_schema%20%3E%20(schema)>)

#### API GatewayUser SchemasOperations

##### [Retrieve all operations from a schema](https://developers.cloudflare.com/api/go/resources/api_gateway/subresources/user_schemas/subresources/operations/methods/list)

Deprecated

client.APIGateway.UserSchemas.Operations.List(ctx, schemaID, params) (\*V4PagePaginationArray\[[UserSchemaOperationListResponse](<https://developers.cloudflare.com/api/go/resources/api_gateway#(resource)%20api_gateway.user_schemas.operations%20%3E%20(model)%20UserSchemaOperationListResponse%20%3E%20(schema)>)], error)

GET/zones/{zone\_id}/api\_gateway/user\_schemas/{schema\_id}/operations

#### API GatewayUser SchemasHosts

##### [Retrieve schema hosts in a zone](https://developers.cloudflare.com/api/go/resources/api_gateway/subresources/user_schemas/subresources/hosts/methods/list)

Deprecated

client.APIGateway.UserSchemas.Hosts.List(ctx, params) (\*V4PagePaginationArray\[[UserSchemaHostListResponse](<https://developers.cloudflare.com/api/go/resources/api_gateway#(resource)%20api_gateway.user_schemas.hosts%20%3E%20(model)%20UserSchemaHostListResponse%20%3E%20(schema)>)], error)

GET/zones/{zone\_id}/api\_gateway/user\_schemas/hosts

#### API GatewayExpression Template

#### API GatewayExpression TemplateFallthrough

##### [Generate a fallthrough WAF expression template](https://developers.cloudflare.com/api/go/resources/api_gateway/subresources/expression_template/subresources/fallthrough/methods/create)

Deprecated

client.APIGateway.ExpressionTemplate.Fallthrough.New(ctx, params) (\*[ExpressionTemplateFallthroughNewResponse](<https://developers.cloudflare.com/api/go/resources/api_gateway#(resource)%20api_gateway.expression_template.fallthrough%20%3E%20(model)%20ExpressionTemplateFallthroughNewResponse%20%3E%20(schema)>), error)

POST/zones/{zone\_id}/api\_gateway/expression-template/fallthrough